// Seven segment LED clock (6 digits) static colon separators /decimal point 
// Written By David Miller and Patrick Hickey
// www.weeblackbox.com 

// 2 buttons to set the time

// could be improved by:
// adding shift register to free up some pins
// use of transistor array to drive higher current LED displays
// add visual or audible alarms  
// add a message display mode (or Easter egg!)
// add stopwatch and timer functions (work in progress!)


// The loop consits of 8 cases
// Click Button S1 to advance through setting modes
// Click Button S2 to set value; hold to advance at multiple Hz
// Case 0: default: displays time 
// Case 1: Displays the date DD MM YY - could be modified to display a message instead
// Cases 2-7: Set Hours:minutes;seconds;day;month;year


//Button code borrowed and modified from http://www.instructables.com/id/DS3231-OLED-clock-with-2-button-menu-setting-and-t/?ALLSTEPS

//Press button 1 to cycle through
// Time
// Date
// change Hour
// change Minute
// change second
// change day
// change month
// change year (max 2099) - can code be modified to go further - I will not be here in 2099! PH
//Press button 2 to increase value by 1
#include <SPI.h>
#include <RTClib.h>
  #include <Wire.h>
  
RTC_DS1307 RTC;
int framecount2 = 0; //Counter for number of display update periods
uint8_t secset = 0; //Index for second RTC setting
uint8_t minset = 1; //Index for minute RTC setting
uint8_t hourset = 2; //Index for hour RTC setting

//RETRO LED display (7segment,4digit) version 1.2 Patrick Hickey, feb 2012                        
//SPECIFY PINS
//CHARACTERS FROM RIGHT TO LEFT I.E. THOUSANDS=LEDPIN4, HUNDREDS = LEDPIN3 TENS = LEDPIN2, UNITS = LEDPIN1
                        
                        
                 
int ledpin1gnd = 10;                          
int ledpin2gnd = 11; 
int ledpin3gnd = 7; 
int ledpin4gnd = 4; 
int ledpin5gnd = 2;
int ledpin6gnd = 9;
int ledpin7gnd = 41;
//SEGMENTS OF THE LEDS A = TOP. 

int ledpina = A0;                           
int ledpinb = A1;
int ledpinc = A2;
int ledpind = A3;
int ledpine = 3;
int ledpinf = 5;
int ledping = 6;
int ledpindp = 8;
int currentdigit = 0;


int button1 = 12;
int button2 = 13;


byte numbers[11] =
{
  B00111111, // 0
  B00000110, // 1
  B01011011, // 2
  B01001111, // 3
  B01100110, // 4
  B01101101, // 5
  B01111101, // 6
  B00000111, // 7
  B01111111, // 8
  B01101111,  // 9
  B10000000 // 10
  
};
// B01234567
//     7
//    216
//    3 5
//     4 0

byte mode = 0; //Mode for time and date setting
byte flash = 0; //Flag for display flashing - toggle once per update interval
int tempset; //Temporary variable for setting time/date

void setup () {
    
  pinMode(ledpin1gnd, OUTPUT);   
  pinMode(ledpin2gnd, OUTPUT);
  pinMode(ledpin3gnd, OUTPUT);
  pinMode(ledpin4gnd, OUTPUT);
  pinMode(ledpin5gnd, OUTPUT);
  pinMode(ledpin6gnd, OUTPUT);
  pinMode(ledpina, OUTPUT);
  pinMode(ledpinb, OUTPUT);
  pinMode(ledpinc, OUTPUT);
  pinMode(ledpind, OUTPUT);
  pinMode(ledpine, OUTPUT);
  pinMode(ledpinf, OUTPUT);
  pinMode(ledping, OUTPUT);
  pinMode(ledpindp, OUTPUT);


  
  //inititation sequence - tests all segments for 100ms
  
  digitalWrite(ledpin1gnd, LOW);    
  digitalWrite(ledpin2gnd, LOW); 
  digitalWrite(ledpin3gnd, LOW); 
  digitalWrite(ledpin4gnd, LOW); 
  digitalWrite(ledpin5gnd, LOW); 
  digitalWrite(ledpin6gnd, LOW); 
  digitalWrite(ledpina, HIGH); 
  digitalWrite(ledpinb, LOW); 
  digitalWrite(ledpinc, LOW); 
  digitalWrite(ledpind, LOW); 
  digitalWrite(ledpine, LOW); 
  digitalWrite(ledpinf, LOW); 
  digitalWrite(ledping, LOW); 
  delay(100);
  
  
  digitalWrite(ledpina, LOW); 
  digitalWrite(ledpinb, HIGH); 
  digitalWrite(ledpinc, HIGH); 
  digitalWrite(ledpind, LOW); 
  digitalWrite(ledpine, LOW); 
  digitalWrite(ledpinf, LOW); 
  digitalWrite(ledping, LOW); 
  delay(100);

  digitalWrite(ledpina, LOW); 
  digitalWrite(ledpinb, LOW); 
  digitalWrite(ledpinc, LOW); 
  digitalWrite(ledpind, HIGH); 
  digitalWrite(ledpine, LOW); 
  digitalWrite(ledpinf, LOW); 
  digitalWrite(ledping, LOW); 
  delay(100);
  
  digitalWrite(ledpina, LOW); 
  digitalWrite(ledpinb, LOW); 
  digitalWrite(ledpinc, LOW); 
  digitalWrite(ledpind, LOW); 
  digitalWrite(ledpine, HIGH); 
  digitalWrite(ledpinf, HIGH); 
  digitalWrite(ledping, LOW); 
  delay(100);
  
  
  digitalWrite(ledpina, LOW); 
  digitalWrite(ledpinb, LOW); 
  digitalWrite(ledpinc, LOW); 
  digitalWrite(ledpind, LOW); 
  digitalWrite(ledpine, LOW); 
  digitalWrite(ledpinf, LOW); 
  digitalWrite(ledping, HIGH); 
   delay(100);
  
     
  digitalWrite(ledpina, LOW); 
  digitalWrite(ledpinb, LOW); 
  digitalWrite(ledpinc, LOW); 
  digitalWrite(ledpind, LOW); 
  digitalWrite(ledpine, LOW); 
  digitalWrite(ledpinf, LOW); 
  digitalWrite(ledping, LOW); 
  digitalWrite(ledpindp, HIGH); 
  delay(100);
  
  //turn off all LEDS
  
  digitalWrite(ledpina, LOW); 
  digitalWrite(ledpinb, LOW); 
  digitalWrite(ledpinc, LOW); 
  digitalWrite(ledpind, LOW); 
  digitalWrite(ledpine, LOW); 
  digitalWrite(ledpinf, LOW); 
  digitalWrite(ledping, LOW); 
    
  digitalWrite(ledpin1gnd, HIGH);    
  digitalWrite(ledpin2gnd, HIGH); 
  digitalWrite(ledpin3gnd, HIGH); 
  digitalWrite(ledpin4gnd, HIGH); 
  digitalWrite(ledpin5gnd, HIGH); 
  digitalWrite(ledpin6gnd, HIGH); 

     

  Serial.begin(9600);
  Wire.begin();
  RTC.begin();
  pinMode(button1, INPUT); //Set pin for time/date mode button to input
  digitalWrite(button1, HIGH); //Turn on pullup resistors

  pinMode(button2, INPUT); //Set pin for time/date set button to input
  digitalWrite(button2, HIGH); //Turn on pullup resistors
 //RTC.adjust(DateTime(__DATE__, __TIME__)); //use this to set clock, then unplug arduino, remove line of code and upload again or it will stay fixed. 
  if (! RTC.isrunning()) {
    Serial.println("RTC is NOT running!");
    // following line sets the RTC to the date & time this sketch was compiled

         
  }
}

void loop () {


      DateTime now = RTC.now();




//Time/Date setting button processing and cursor flashing
//CURSOR COORDINATES ARE SET TO MATCH TIME/DATE FIELD - DO NOT CHANGE!!
//Digital and analog time/date display updates with new settings at 5Hz as settings are changed
  switch(mode)
  {
    case 0: 
      
      currentdigit = (now.hour()/10);
      showSprite((currentdigit),0,0);
      currentdigit = (now.hour()%10);
      showSprite((currentdigit),1,0); // this is where the dp is turned on, after hour digit 
      currentdigit = (now.minute()/10);
      showSprite((currentdigit),2,0);
      currentdigit = now.minute()%10;
      showSprite((currentdigit),3,0);
      currentdigit = (now.second()/10);
      showSprite((currentdigit),4,0);
      currentdigit = now.second()%10;
      showSprite((currentdigit),5,0);

      
           currentdigit = (10);
           showSprite((currentdigit),6,1);
      break;
    
    case 1:
      currentdigit = (now.day()/10);
      showSprite((currentdigit),0,0);
      currentdigit = (now.day()%10);
      showSprite((currentdigit),1,0); // this is where the dp is turned on, after hour digit 
      currentdigit = (now.month()/10);
      showSprite((currentdigit),2,0);
      currentdigit = now.month()%10;
      showSprite((currentdigit),3,0);
      currentdigit = (now.year()%100/10);
      showSprite((currentdigit),4,0);
      currentdigit = now.year()%10;
      showSprite((currentdigit),5,0);
    break;


    case 2: //Hour setting
      //if(flash){display.drawRect(0,8,12,8,WHITE);} //Display rectangle cursor every other display update (5Hz blink)
      
      currentdigit = (now.hour()/10);
      showSprite((currentdigit),0,0);
      currentdigit = (now.hour()%10);
      showSprite((currentdigit),1,0);

      showBlankSprite(2);
      showBlankSprite(3); 
      showBlankSprite(4);
      showBlankSprite(5); 
      
      if(!digitalRead(button2) && (!flash)){ //Update setting at 5Hz rate if button held down
        ;
        tempset = now.hour(); //Get the current hour and save in temporary variable
        tempset = tempset + 1; //Increment the hour at 5Hz rate
        delay(200);
        if(tempset > 23){tempset = 0;} //Roll over hour after 23rd hour (setting done in 24-hour mode)
        RTC.adjust(DateTime(now.year(), now.month(), now.day(), tempset, now.minute(), now.second()));
        //now.hour() = tempset; //After each update, write the hour back to the time structure
        
        //set_rtc_field(t, hourset); //Write the set field only back to the real time clock module after each update
      }
      break;
    case 3: //Minute setting
      //if(flash){display.drawRect(18,8,12,8,WHITE);} //Display rectangle cursor every other display update (5Hz blink)
      
      showBlankSprite(0);
      showBlankSprite(1); 
      currentdigit = (now.minute()/10);
      showSprite((currentdigit),2,0);
      currentdigit = (now.minute()%10);
      showSprite((currentdigit),3,0);

      showBlankSprite(4);
      showBlankSprite(5); 

      if(!digitalRead(button2) && (!flash)){ //Update setting at 5Hz rate if button held down
        tempset = now.minute(); //Get the current minute and save in temporary variable
        tempset = tempset + 1; //Increment the minute at 5Hz rate
        delay(200);
        if(tempset > 59){tempset = 0;} //Roll over minute to zero after 59th minute
        RTC.adjust(DateTime(now.year(), now.month(), now.day(), now.hour(), tempset, now.second()));
      }
      break;
      
     //Set clock + 1 minute, then press and hold to freeze second setting.
     //Release button at 00 seconds to synchronize clock to external time source.
    case 4: //Second synchronization

      showBlankSprite(0);
      showBlankSprite(1);
      showBlankSprite(2);
      showBlankSprite(3);
      currentdigit = (now.second()/10);
      showSprite((currentdigit),4,0);
      currentdigit = now.second()%10;
      showSprite((currentdigit),5,0);
      //if(flash){display.drawRect(36,8,12,8,WHITE);} //Display rectangle cursor every other display update (5Hz blink)
      
      if(!digitalRead(button2) && (!flash)){ //Reset second to zero at 5Hz rate if button held down
        RTC.adjust(DateTime(now.year(), now.month(), now.day(), now.hour(), now.minute(), 0));
       }
      break;

      case 5: //day setting
      //if(flash){display.drawRect(0,8,12,8,WHITE);} //Display rectangle cursor every other display update (5Hz blink)
      
      currentdigit = (now.day()/10);
      showSprite((currentdigit),0,0);
      currentdigit = (now.day()%10);
      showSprite((currentdigit),1,0);

      showBlankSprite(2);
      showBlankSprite(3); 
      showBlankSprite(4);
      showBlankSprite(5); 
      
      if(!digitalRead(button2) && (!flash)){ //Update setting at 5Hz rate if button held down
        ;
        tempset = now.day(); //Get the current hour and save in temporary variable
        tempset = tempset + 1; //Increment the hour at 5Hz rate
        delay(200);
        if(tempset > 31){tempset = 0;} //Roll over hour after 23rd hour (setting done in 24-hour mode)
        RTC.adjust(DateTime(now.year(), now.month(), tempset, now.hour(), now.minute(), now.second()));
        //now.hour() = tempset; //After each update, write the hour back to the time structure
        
        //set_rtc_field(t, hourset); //Write the set field only back to the real time clock module after each update
      }
      break;
      
      case 6: //Month setting
      //if(flash){display.drawRect(0,8,12,8,WHITE);} //Display rectangle cursor every other display update (5Hz blink)
      

      showBlankSprite(0);
      showBlankSprite(1); 
      currentdigit = (now.month()/10);
      showSprite((currentdigit),2,0);
      currentdigit = (now.month()%10);
      showSprite((currentdigit),3,0);

      showBlankSprite(4);
      showBlankSprite(5); 
      
      if(!digitalRead(button2) && (!flash)){ //Update setting at 5Hz rate if button held down
        ;
        tempset = now.month(); //Get the current hour and save in temporary variable
        tempset = tempset + 1; //Increment the hour at 5Hz rate
        delay(200);
        

        if(tempset > 12){tempset = 0;} //Roll over hour after 23rd hour (setting done in 24-hour mode)
        RTC.adjust(DateTime(now.year(), tempset, now.day(), now.hour(), now.minute(), now.second()));
        //now.hour() = tempset; //After each update, write the hour back to the time structure
        
        //set_rtc_field(t, hourset); //Write the set field only back to the real time clock module after each update
      }
      break;
      
      case 7: //Year setting
      //if(flash){display.drawRect(0,8,12,8,WHITE);} //Display rectangle cursor every other display update (5Hz blink)
      
      
      showBlankSprite(0);
      showBlankSprite(1); 
      showBlankSprite(2);
      showBlankSprite(3); 
      currentdigit = (now.year()%100/10);
      showSprite((currentdigit),4,0);
      currentdigit = (now.year()%10);
      showSprite((currentdigit),5,0);


      if(!digitalRead(button2) && (!flash)){ //Update setting at 5Hz rate if button held down
        ;
        tempset = now.year(); //Get the current hour and save in temporary variable
        tempset = tempset + 1; //Increment the hour at 5Hz rate
        delay(200);
        if(tempset > 2099){tempset = 2016;} //Roll over hour after 23rd hour (setting done in 24-hour mode)
        RTC.adjust(DateTime(tempset, now.month(), now.day(), now.hour(), now.minute(), now.second()));
        //now.hour() = tempset; //After each update, write the hour back to the time structure
        
        //set_rtc_field(t, hourset); //Write the set field only back to the real time clock module after each update
      }
      break;
      
  }
      
//  prev = now; //Reset variable for display and time update rate


//Clock setting mode set - outside time/display update processing for faster button response
  if(!digitalRead(button1)){ //Read setting mode button
    delay(25); //100ms debounce time
    if(!digitalRead(button1)){ //Activate setting mode change after 100ms button press
      
      mode = mode + 1; //Increment the time setting mode on each button press

      delay(200);
      framecount2 = 0;  //Reset cycle counter if button pressed to delay auto return to normal mode
      if(mode > 7){mode = 0;} //Roll the mode setting after 7th mode
      while(!digitalRead(button1)){} //Wait for button release (freezes all display processing and time updates while button held, but RTC continues to keep time)
    }
  }











}
void showSprite(int posit, int numindex, int dp)
{
      
      switch (numindex)  //select which digit, 0 = 1000s, 1 = 100s, 2 = 10s, 3 = 1s units
      {
        case 0:
          digitalWrite(ledpin1gnd, HIGH);    
          digitalWrite(ledpin2gnd, HIGH); 
          digitalWrite(ledpin3gnd, HIGH); 
          digitalWrite(ledpin4gnd, HIGH); 
          digitalWrite(ledpin5gnd, HIGH); 
          digitalWrite(ledpin6gnd, LOW); 
          break;

        case 1:
         digitalWrite(ledpin1gnd, HIGH);    
          digitalWrite(ledpin2gnd, HIGH); 
          digitalWrite(ledpin3gnd, HIGH); 
          digitalWrite(ledpin4gnd, HIGH); 
          digitalWrite(ledpin5gnd, LOW); 
          digitalWrite(ledpin6gnd, HIGH); 
          break;
        
        case 2:
         digitalWrite(ledpin1gnd, HIGH);    
          digitalWrite(ledpin2gnd, HIGH); 
          digitalWrite(ledpin3gnd, HIGH); 
          digitalWrite(ledpin4gnd, LOW); 
          digitalWrite(ledpin5gnd, HIGH); 
          digitalWrite(ledpin6gnd, HIGH); 
          break;
        
        case 3:
         digitalWrite(ledpin1gnd, HIGH);    
          digitalWrite(ledpin2gnd, HIGH); 
          digitalWrite(ledpin3gnd, LOW); 
          digitalWrite(ledpin4gnd, HIGH); 
          digitalWrite(ledpin5gnd, HIGH); 
          digitalWrite(ledpin6gnd, HIGH); 
          break;
          
           case 4:
         digitalWrite(ledpin1gnd, HIGH);    
          digitalWrite(ledpin2gnd, LOW); 
          digitalWrite(ledpin3gnd, HIGH); 
          digitalWrite(ledpin4gnd, HIGH); 
          digitalWrite(ledpin5gnd, HIGH); 
          digitalWrite(ledpin6gnd, HIGH); 
          break;
   
           case 5:
         digitalWrite(ledpin1gnd, LOW);    
          digitalWrite(ledpin2gnd, HIGH); 
          digitalWrite(ledpin3gnd, HIGH); 
          digitalWrite(ledpin4gnd, HIGH); 
          digitalWrite(ledpin5gnd, HIGH); 
          digitalWrite(ledpin6gnd, HIGH); 
          break;     

     }
      
      int number =  numbers[posit]; // reads the selected number from the array B,DP,g,f,e,d,c,b,a
      digitalWrite(ledpina, bitRead(number, 0)); 
      digitalWrite(ledpinb, bitRead(number, 1)); 
      digitalWrite(ledpinc, bitRead(number, 2)); 
      digitalWrite(ledpind, bitRead(number, 3)); 
      digitalWrite(ledpine, bitRead(number, 4)); 
      digitalWrite(ledpinf, bitRead(number, 5)); 
      digitalWrite(ledping, bitRead(number, 6)); 
      digitalWrite(ledpindp, dp); // show decimal point or not
      delay(2);
          digitalWrite(ledpina, LOW); 
          digitalWrite(ledpinb, LOW); 
          digitalWrite(ledpinc, LOW); 
          digitalWrite(ledpind, LOW); 
          digitalWrite(ledpine, LOW);
          digitalWrite(ledpinf, LOW); 
          digitalWrite(ledping, LOW); 
          digitalWrite(ledpindp, LOW); 
         digitalWrite(ledpin1gnd, HIGH);    
          digitalWrite(ledpin2gnd, HIGH); 
          digitalWrite(ledpin3gnd, HIGH); 
          digitalWrite(ledpin4gnd, HIGH); 
          digitalWrite(ledpin5gnd, HIGH); 
          digitalWrite(ledpin6gnd, HIGH); 

}
void showBlankSprite(int numindex)
{
      
      switch (numindex)  //select which digit, 0 = 1000s, 1 = 100s, 2 = 10s, 3 = 1s units
      {
        case 0:
          digitalWrite(ledpin1gnd, HIGH);    
          digitalWrite(ledpin2gnd, HIGH); 
          digitalWrite(ledpin3gnd, HIGH); 
          digitalWrite(ledpin4gnd, HIGH); 
          digitalWrite(ledpin5gnd, HIGH); 
          digitalWrite(ledpin6gnd, LOW); 
          break;

        case 1:
         digitalWrite(ledpin1gnd, HIGH);    
          digitalWrite(ledpin2gnd, HIGH); 
          digitalWrite(ledpin3gnd, HIGH); 
          digitalWrite(ledpin4gnd, HIGH); 
          digitalWrite(ledpin5gnd, LOW); 
          digitalWrite(ledpin6gnd, HIGH); 
          break;
        
        case 2:
         digitalWrite(ledpin1gnd, HIGH);    
          digitalWrite(ledpin2gnd, HIGH); 
          digitalWrite(ledpin3gnd, HIGH); 
          digitalWrite(ledpin4gnd, LOW); 
          digitalWrite(ledpin5gnd, HIGH); 
          digitalWrite(ledpin6gnd, HIGH); 
          break;
        
        case 3:
         digitalWrite(ledpin1gnd, HIGH);    
          digitalWrite(ledpin2gnd, HIGH); 
          digitalWrite(ledpin3gnd, LOW); 
          digitalWrite(ledpin4gnd, HIGH); 
          digitalWrite(ledpin5gnd, HIGH); 
          digitalWrite(ledpin6gnd, HIGH); 
          break;
          
           case 4:
         digitalWrite(ledpin1gnd, HIGH);    
          digitalWrite(ledpin2gnd, LOW); 
          digitalWrite(ledpin3gnd, HIGH); 
          digitalWrite(ledpin4gnd, HIGH); 
          digitalWrite(ledpin5gnd, HIGH); 
          digitalWrite(ledpin6gnd, HIGH); 
          break;
   
           case 5:
         digitalWrite(ledpin1gnd, LOW);    
          digitalWrite(ledpin2gnd, HIGH); 
          digitalWrite(ledpin3gnd, HIGH); 
          digitalWrite(ledpin4gnd, HIGH); 
          digitalWrite(ledpin5gnd, HIGH); 
          digitalWrite(ledpin6gnd, HIGH); 
          break;     

     }
      
      //blank    
 
      digitalWrite(ledpina, LOW); 
      digitalWrite(ledpinb, LOW); 
      digitalWrite(ledpinc, LOW); 
      digitalWrite(ledpind, LOW); 
      digitalWrite(ledpine, LOW);
      digitalWrite(ledpinf, LOW); 
      digitalWrite(ledping, LOW); 
      digitalWrite(ledpindp, LOW); 
      digitalWrite(ledpin1gnd, HIGH);    
      digitalWrite(ledpin2gnd, HIGH); 
      digitalWrite(ledpin3gnd, HIGH); 
      digitalWrite(ledpin4gnd, HIGH); 
      digitalWrite(ledpin5gnd, HIGH); 
      digitalWrite(ledpin6gnd, HIGH); 
     delay(2);
}

